#ifndef __RSA_H__
#define __RSA_H__

#include <stdio.h>
//#include <stdlib.h>
#include <stdint.h>



//Guarda la clave publica
struct public_key_class{
  long modulus;
  long exponent;
};
//Guarda la clave privada
struct private_key_class{
  long modulus;
  long exponent;
};

//Esta funcin genera claves pblicas y privadas, luego las almacena en las estructuras que le facilitamos
void rsa_gen_keys(struct public_key_class *pub, struct private_key_class *priv);

//Esta funcin cifrar los datos de mensaje. Devuelve un puntero a puntero
// matriz que contiene los datos cifrados o NULL en caso de error. Este puntero debera ser liberado cuando
// se ha terminado.
long *rsa_encrypt(const uint8_t *message, const unsigned long message_size, const struct public_key_class *pub);

// Esta funcin descifrar los datos de mensaje. Devuelve un puntero a unpuntero
// que contiene los datos descifrados, o NULL cuando falla. Este puntero debera ser liberado cuando
// has terminado.
char *rsa_decrypt(const long *message, const unsigned long message_size, const struct private_key_class *pub);


//Realiza la exponeciacin modular
long rsa_modExp(long b, long e, long m);

//Realiza la operacin de Euclides extendido
long ExtEuclid(long a, long b);

//Obtiene el maximo comun divisor
long gcd(long a, long b);

#endif
