//import gnu.io.*;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
//import java.io.UnsupportedEncodingException;
//import java.util.Enumeration;
import java.util.Vector;



//import com.fazecast.jSerialComm.*;
import com.fazecast.jSerialComm.SerialPort;

public class Network_jserial {
	private InputStream inputStream;
	private OutputStream outputStream;
	
	/**
	 * El estado de la conexion
	 */
	private boolean connected = false;
	
	/**
	 * Hilo que recibe los datos.
	 */
	//private Thread reader;
	private SerialPort serialPort;
	
	//private boolean end = false;

	/**
	 * Clase que implementa Networ_iface
	 */
	private Network_iface contact;


	private int divider;
	
	private int id;

	//private int[] tempBytes;
	int numTempBytes = 0, numTotBytes = 0;


	public Network_jserial(int id, Network_iface contact, int divider) {
		this.contact = contact;
		this.divider = divider;
		if (this.divider > 255)
			this.divider = 255;
		if (this.divider < 0)
			this.divider = 0;
		this.id = id;
		//tempBytes = new int[1024];
	}

	//Constructor de la clase
	public Network_jserial(int id, Network_iface contact) {
		this(id, contact, 255);
	}

	//Constructor de la clase
	public Network_jserial(Network_iface contact) {
		this(0, contact);
	}
	

	//Devuelve los puertos disponibles
	public Vector<String> getPortList() {
		SerialPort[] portList;
		Vector<String> portVect = new Vector<String>();
		portList = SerialPort.getCommPorts();


		
		for (int i = 0; i < portList.length; i++) {
			
			//if (portList[i].getDescriptivePortName().contains("COM")) {
				portVect.add(portList[i].getDescriptivePortName());
			//}
		}
		contact.writeLog(id, "Encontrados los siguientes puertos:\n");
		for (int i = 0; i < portVect.size(); i++) {
			contact.writeLog(id, ("   " + (String) portVect.elementAt(i)+"\n"));
		}

		return portVect;
	}
	
	
	//Conecta con el puertoespecificado
	public boolean connect(String portName) {
		return connect(portName, 115200);
	}

	
	
	//Conecta con el puerto y la velocidad que especificada
	public boolean connect(String portName, int speed) {
		boolean conn = false;
		SerialPort[] ports = SerialPort.getCommPorts();
		for (SerialPort p : ports) {
			if (p.getDescriptivePortName().contains(portName)) {
				serialPort = p;
				break;
			}
		}
		if(serialPort==null) {
			contact.writeLog(id, "El puerto no existe\n");
		}else {
			
			if(serialPort.isOpen()) {
				contact.writeLog(id, "El puerto ya esta abierto\n");
			}else {
				serialPort.setComPortParameters(speed, 8, 1, 0);
				if(serialPort.openPort()) {

				System.out.println(serialPort.getBaudRate() + " | "
						+ serialPort.getNumDataBits() + " | "
						+ serialPort.getNumStopBits() + " | "
						+ serialPort.getDescriptivePortName());
				inputStream = serialPort.getInputStream();
				outputStream = serialPort.getOutputStream();
				connected = true;
				contact.writeLog(id, "La conexin en el puerto " + portName + " ha sido establecida\n");
				//serialPort.setComPortTimeouts(SerialPort.TIMEOUT_NONBLOCKING,0,0);
				conn = true;}
				else {
					contact.writeLog(id, "La conexin se encuentra en uso\n");
				}
			}
		}
		

		return conn;
	}


	//Lee desde el puerto al cual esta conectado
	public boolean read() {
		String cadena = "";
		String[] partes;
		String mensaje = "";
		String checksum = "";
		int aux=0;

		boolean tiempo_excedido = false;
		long time_start;
		time_start = System.currentTimeMillis();
		System.out.println(time_start);
		time_start = time_start + 30000;
		System.out.println(time_start);
		while ((!cadena.contains("OK")) && (!cadena.contains("KO")) && (!tiempo_excedido)&&(aux!=-1)) {
			try {
				
				if(inputStream.available()>0){
				aux = inputStream.read(); // aqui estamos obteniendo nuestro dato serial
				
				if (aux > 0) {
					// contact.writeLog(0,""+(char) aux);
					System.out.print((char) aux);
					cadena = cadena + (char) aux;

				}
				}
				if (time_start < System.currentTimeMillis()) {
					tiempo_excedido = true;
				}

			} catch (Exception e) {
			}
		}
		if (tiempo_excedido) {
			cadena = "\nTiempo excedido\n-KO";
		} else {

			partes = cadena.split("\n");
			int i = 0;
			cadena = "";
			for (i = 0; i < partes.length; i++) {
				if (!partes[i].equals("[Press ENTER to execute the previous command again]\r")) {
					cadena = cadena + partes[i] + "\n";
				}

			}

			if (cadena.contains("Mensaje: ")) {
				partes = cadena.split("Mensaje: ");
				partes = partes[1].split("\r\nchecksum");
				mensaje = partes[0];
				contact.writeArchivo(0, mensaje);
				partes = mensaje.split("-OK");
				contact.writeRespuesta(0, partes[0]);
				
			}
			if (cadena.contains("Clave Generada: ")) {
				partes = cadena.split("Clave Generada: ");
				partes = partes[1].split("-OK");
				contact.writeClave(0, partes[0]);

			}
			if (cadena.contains("checksum:")) {
				partes = cadena.split("checksum:");
				partes = partes[1].split("-OK");
				checksum = partes[0];
				//contact.compruebaChecksum(mensaje, partes[0]);
			}
			if (cadena.contains("Clave Publica: ")) {
				partes = cadena.split("Clave Publica: ");
				partes = partes[1].split("\\r\\nModulo:");
				contact.setPublicKey(Long.parseLong(partes[0], 10)  );
				//contact.compruebaChecksum(mensaje, partes[0]);
			}
			if (cadena.contains("Modulo:")) {
				partes = cadena.split("Modulo:");
				partes = partes[1].split("\\r\\n");
				contact.setModule(Long.parseLong(partes[0], 10));
				//contact.compruebaChecksum(mensaje, partes[0]);
			}
			if (cadena.contains("Mensaje encriptado: ")) {
				partes = cadena.split("Mensaje encriptado: ");
				partes = partes[1].split("-OK");
				contact.writeRespuesta(1, partes[0]);
				//contact.compruebaChecksum(mensaje, partes[0]);
			}
			

			/*
			 * if((!mensaje.equals(""))&&(!checksum.equals(""))) {
			 * 
			 * 
			 * }
			 */
		}
		if (cadena.contains("OK")) {
			partes = cadena.split("-OK");
			cadena = partes[0];
			contact.writeLog(0, cadena);
			if ((!mensaje.equals("")) && (!checksum.equals(""))) {
				contact.compruebaChecksum(mensaje.trim(), checksum);

			}
			return true;
		} else {
			partes = cadena.split("-KO");
			cadena = partes[0];
			contact.writeLog(0, cadena);
			return false;
		}

	}

	//Desconecta
	public boolean disconnect() {
		boolean disconn = true;
		//end = true;
		/*try {
			reader.join();
		} catch (InterruptedException e1) {
			e1.printStackTrace();
			disconn = false;
		}*/
		try {
			outputStream.close();
			inputStream.close();
		} catch (IOException e) {
			e.printStackTrace();
			disconn = false;
		}
		//serialPort.close();
		serialPort.closePort();
		connected = false;
		//contact.networkDisconnected(id);
		contact.writeLog(id, "Desconectado\n");
		return disconn;
	}

	
	public boolean isConnected() {
		return connected;
	}

	public boolean writeSerial(String message) {
		boolean success = false;
		if (isConnected()) {
			try {
				outputStream.write(message.getBytes("ISO-8859-1"));
				success = true;
			} catch (IOException e) {
				disconnect();
			}
		} else {
			contact.writeLog(id, "El puerto no esta conectado.\n");
		}
		return success;
	}

}