
public class Rsa2 {

	long pubkey;
	long pubmodulus;
	long prikey;
	long primodulus;

	int primos[] = { 2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97,
			101, 103, 107, 109, 113, 127, 131, 137, 139, 149, 151, 157, 163, 167, 173, 179, 181, 191, 193, 197, 199,
			211, 223, 227, 229, 233, 239, 241, 251, 257, 263, 269, 271, 277, 281, 283, 293, 307, 311, 313, 317, 331 };

	// Maximo comun divisor
	long gcd(long a, long b) {
		long c;
		while (a != 0) {
			c = a;
			a = b % a;
			b = c;
		}
		return b;
	}

	// Euclides Extendido
	public long ExtEuclid(long a, long b) {
		long x = 0, y = 1, u = 1, v = 0, gcd = b, m, n, q, r;
		while (a != 0) {
			q = gcd / a;
			r = gcd % a;
			m = x - u * q;
			n = y - v * q;
			gcd = a;
			a = r;
			x = u;
			y = v;
			u = m;
			v = n;
		}
		return y;
	}

	// Exponente Modular
	public static long rsa_modExp(long b, long e, long m) {
		if (b < 0 || e < 0 || m <= 0) {
			// exit(1);
		}
		b = b % m;
		if (e == 0)
			return 1;
		else if (e == 1)
			return b;
		else if (e % 2 == 0) {
			return (rsa_modExp(b * b % m, e / 2, m) % m);
		} else if (e % 2 == 1) {
			return (b * rsa_modExp(b, (e - 1), m) % m);
		} else {
			return 0;
		}

	}

	// Encripta el mensaje con la clave y modulo especificados
	public static long[] rsa_encrypt(String mensaje, long tamano, long exponente, long modulo) {
		long encrypted[];
		encrypted = new long[(int) tamano];
		int i = 0;
		for (i = 0; i < tamano; i++) {
			// long trozo = Character.getNumericValue(mensaje.charAt(i));
			long trozo = (long) mensaje.charAt(i);
			System.out.print(trozo + "\n");
			encrypted[i] = rsa_modExp(trozo, exponente, modulo);
		}
		return encrypted;
	}

	// Desencripta el mensaje con la clave y modulo especificados
	public String rsa_decrypt(long[] mensaje, long tamano, long exponente, long modulo) {
		String decrypted = "";
		// String prueba = new Long(mensaje).toString();
		System.out.println("Salida:" + " " + tamano + " " + exponente + " " + modulo);

		int i = 0;
		for (i = 0; i < tamano; i++) {
			System.out.println(i + " " + mensaje[i]);
			decrypted = decrypted + (char) rsa_modExp(mensaje[i], exponente, modulo);
		}
		return decrypted;
	}

	void rsa_gen_keys() {
		

		long p = 0;
		long q = 0;

		long e = (long) (Math.pow(2, 8) + 1);
		// long e = 65537;
		long d = 0;
		
		long max = 0;
		long phi_max = 0;

		while ((p == q) || (gcd(phi_max, e) != 1) || (phi_max < 0)) {


			int a = (int) (Math.random() * primos.length);
			int b = (int) (Math.random() * primos.length);

		//Obtenemos el p y q de la lista de primos

			p = primos[a];
			q = primos[b];

			max = p * q;
			phi_max = (p - 1) * (q - 1);
			System.out.println("p: " + p + " q: " + q + " max: " + max + " phi_max: " + phi_max + " primos.length: "
					+ primos.length);
		}

	    // A continuacin, debemos elegir a, b, de modo que a * max + b * e = gcd (max, e).
	    // En realidad, solo necesitamos b aqu, y de acuerdo con la notacin habitual de RSA
	    // lo llamaremos d. Tambin nos gustara asegurarnos de obtener una representacin de
	    // d como positiva, de ah el while.
		d = ExtEuclid(phi_max, e);
		while (d < 0) {
			d = d + phi_max;
		}

		//Guardamos la clave publica privad y modulo
		pubmodulus = max;
		pubkey = e;

		primodulus = max;
		prikey = d;
	}
	

}
